# ToF Ros node

This is a node wrapper around the tof library and kea camera class showing off some of the advanced features of the tof library for optimal performance. The camera starts streaming as soon as one of it's publishers is subscribed to. In this node we assume you already have your camera preconfigured with the correct camera config and that you have a processing config you've settled on and that you'll load it from disk.

The node accepts the following private parameters
- serial: (string) The serial of the camera you want to connect to. Default empty
- config_file: (string) The processing config file to load from disk. Default empty
- log: (bool) Whether to output log messages from the tof library. Default true
- queue_size: (int) The amount of user pointers to queue up, if the node isn't used in a nodelet the default should be plenty. But in a nodelet where you share data you might want to up the number if you encounter weird memory corruption bugs. Default 10

The node has been tested with ros noetic in a docker container

## Normal

Copy the folder this readme is in into your catkin workspace.

    cp -R examples/ros ~/catkin_ws/src/kea_camera

Build like usual:

    catkin_make

Source the setup.bash

    source devel/setup.bash

Run the ros node

    rosrun kea_camera kea_camera_node

## Docker

To build image:

    docker build -t ros-tof .

To run image:

    docker run -itd --name ros-develop --network=host -v $(pwd):/workspace/src/kea_camera/ ros-tof

Afterwards you can follow the normal instructions starting from build like usual.
